#define _CRT_SECURE_NO_WARNINGS
#include <stdint.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

// 
void input_parameters(double *a, double *b, double *c, int task);
void output_results(double result1, double result2, int task);
void solve_quadratic_equation();
void solve_linear_sustem();
void solve_factorial();
int validate_input(int min, int max);

int main() 
{
	system("chcp 1251>null");
	int choice;

	do {
		// 
		printf("  \n");
		printf("1.   \n");
		printf("2.     \n");
		printf("3.  (\n");
		printf("0. \n");
		printf("  :");
		choice = validate_input(0, 3);
		//  
		switch (choice) {
		case 1:
			solve_quadratic_equation();
			break;
		case 2:
			solve_linear_sustem();
			break;
		case 3:
			solve_factorial();
			break;
		case 0:
			printf("   \n");
			break;
		default:
			printf(" ! \n");
			break;
		}
	} while (choice != 0);
	return 0;
}

//   
int validate_input(int min, int max) {
	int value;
	while (scanf("%d", &value) != 1 || value < min || value > max) {
		printf("!    %d  %d: ", min, max);
		while (getchar() != '\n'); // 
	}
	return value;
}

//   
void input_parameters(double* a, double* b, double* c, int task) {
	if (task == 1) {
		//    
		printf("  , b  c   : \n");
		while (scanf("%lf %lf %lf", a, b, c) != 3) {
			printf("!     : ");
			while (getchar() != '\n');
		}
	}
	else if (task == 2) {
		//     
		printf("    : \n");
		while (scanf("%lf %lf %lf", a, b, c) != 3) {
			printf("!     : ");
			while (getchar() != '\n');
		}
	}
}

//   
void output_results(double result1, double result2, int task) {
	if (task == 1) {
		printf("  : %.2lf  %.2lf \n", result1, result2);
	}
	else if (task == 2) {
		printf("  : x = %.2lf, y = %.2lf \n", result1, result2);
	}
	else if (task == 3) {
		printf(" : %.0lf \n", result1);
	}
}

void solve_quadratic_equation() {
	double a, b, c, discriminant, root1, root2;

	input_parameters(&a, &b, &c, 1);

	discriminant = b * b - 4 * a * c;

	if (discriminant > 0) {
		root1 = (-b + sqrt(discriminant)) / (2 * a);
		root2 = (-b - sqrt(discriminant)) / (2 * a);
		output_results(root1, root2, 1);
	}
	else if (discriminant == 0) {
		root1 = -b / (2 * a);
		output_results(root1, root1, 1);
	}
	else {
		printf("  (  ). \n");
	}
}

//    
void solve_linear_sustem() {
	double a1, b1, c1, a2, b2, c2, determinant, x, y;

	printf("     \n");
	while (scanf("%lf %lf %lf %lf %lf %lf", &a1, &b1, &c1, &a2, &b2, &c2) != 6) {
		printf("!     : ");
		while (getchar() != '\n');
	}

	determinant = a1 * b2 - a2 * b1;

	if (determinant != 0) {
		x = (c1 * b2 - c2 * b1) / determinant;
		y = (a1 * c2 - a2 * c1) / determinant;
		output_results(x, y, 2);
	}
	else {
		printf("    . \n");
	}
}

// 
void solve_factorial() {
	int n;
	double factorial = 1;
	printf("    : ");
	n = validate_input(0, 20); //       

	for (int i = 1; i <= n; i++) {
		factorial *= i;
	}

	output_results(factorial, 0, 3);
}